# ZeroTest

To set up a ZeroTest instance, simply set up a Web server to host `index.html` over an unencrypted HTTP connection. (ZeroTest will not work if loaded over HTTPS, because [restrictions on mixed content](https://developer.mozilla.org/en-US/docs/Web/Security/Mixed_content) will block its requests.)

A public instance is available at [https://zerotest.kj7rrv.com/](https://zerotest.kj7rrv.com/); it uses the following Nginx configuration:

```nginx
server {
    listen 80;
    listen [::]:80;
    server_name zerotest.kj7rrv.com;

    add_header Content-Security-Policy "connect-src 0.0.0.0:*;";

    root /var/www/zerotest;
    charset utf-8;
}

server {
    listen 443;
    listen [::]:443;
    server_name zerotest.kj7rrv.com;

    return 301 http://zerotest.kj7rrv.com;

    include /etc/nginx/templates/ssl.tmpl;
}
```

Note that if a [Content Security Policy](https://developer.mozilla.org/en-US/docs/Web/HTTP/CSP) is set, it must allow `fetch` requests to all ports on `0.0.0.0`; the header in the example Nginx configuration (`connect-src 0.0.0.0:*;`) works well.